#line 1 "C:/Evil Genius/MikroProC/P18F4685/X10 Color Touch Pen Cal/X10_Color_Touch_driver.c"
#line 1 "c:/evil genius/mikroproc/p18f4685/x10 color touch pen cal/x10_color_touch_objects.h"
enum GlcdColor {_clClear, _clDraw, _clInvert};

typedef struct Screen TScreen;

typedef struct Button {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TButton;

typedef struct Label {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TLabel;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned short ObjectsCount;
 unsigned int ButtonsCount;
 TButton * const code *Buttons;
 unsigned int LabelsCount;
 TLabel * const code *Labels;
};

extern TScreen Screen1;
extern TLabel Label1;
extern TLabel Label2;
extern TButton Button1;
extern TButton Button2;
extern TButton Button3;
extern TButton Button4;
extern TButton Button5;
extern TButton Button6;
extern TButton Button7;
extern TButton Button8;
extern TButton Button17;
extern TButton Button18;
extern TButton Button19;
extern TLabel Label5;
extern TLabel Label6;
extern TButton * const code Screen1_Buttons[11];
extern TLabel * const code Screen1_Labels[4];


extern TScreen Screen2;
extern TLabel Label3;
extern TLabel Label4;
extern TButton Button9;
extern TButton Button10;
extern TButton Button11;
extern TButton Button12;
extern TButton Button13;
extern TButton Button14;
extern TButton Button15;
extern TButton Button16;
extern TButton Button24;
extern TButton Button25;
extern TButton Button22;
extern TLabel Label7;
extern TLabel Label8;
extern TButton * const code Screen2_Buttons[11];
extern TLabel * const code Screen2_Labels[4];





void Button1Down();
void Button2Down();
void Button3Down();
void Button4Down();
void Button5Down();
void Button6Down();
void Button7Down();
void Button8Down();
void Button17Down();
void Button18Down();
void Button19Down();
void Button9Down();
void Button10Down();
void Button11Down();
void Button12Down();
void Button13Down();
void Button14Down();
void Button15Down();
void Button16Down();
void Button24Down();
void Button25Down();
void Button22Down();




extern char Label1_Caption[];
extern char Label2_Caption[];
extern char Button1_Caption[];
extern char Button2_Caption[];
extern char Button3_Caption[];
extern char Button4_Caption[];
extern char Button5_Caption[];
extern char Button6_Caption[];
extern char Button7_Caption[];
extern char Button8_Caption[];
extern char Button17_Caption[];
extern char Button18_Caption[];
extern char Button19_Caption[];
extern char Label5_Caption[];
extern char Label6_Caption[];
extern char Label3_Caption[];
extern char Label4_Caption[];
extern char Button9_Caption[];
extern char Button10_Caption[];
extern char Button11_Caption[];
extern char Button12_Caption[];
extern char Button13_Caption[];
extern char Button14_Caption[];
extern char Button15_Caption[];
extern char Button16_Caption[];
extern char Button24_Caption[];
extern char Button25_Caption[];
extern char Button22_Caption[];
extern char Label7_Caption[];
extern char Label8_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawButton(TButton *aButton);
void DrawLabel(TLabel *ALabel);
void Check_TP();
void Start_TP();
#line 1 "c:/evil genius/mikroproc/p18f4685/x10 color touch pen cal/x10_color_touch_resources.h"
const code char Tahoma18x18_Bold[];
const code char Tahoma16x19_Regular[];
const code char Tahoma19x19_Bold[];
#line 5 "C:/Evil Genius/MikroProC/P18F4685/X10 Color Touch Pen Cal/X10_Color_Touch_driver.c"
char TFT_DataPort at PORTD;
sbit TFT_RST at RB0_bit;
sbit TFT_BLED at RB5_bit;
sbit TFT_RS at RB3_bit;
sbit TFT_CS at RB4_bit;
sbit TFT_RD at RB1_bit;
sbit TFT_WR at RB2_bit;
char TFT_DataPort_Direction at TRISD;
sbit TFT_RST_Direction at TRISB0_bit;
sbit TFT_BLED_Direction at TRISB5_bit;
sbit TFT_RS_Direction at TRISB3_bit;
sbit TFT_CS_Direction at TRISB4_bit;
sbit TFT_RD_Direction at TRISB1_bit;
sbit TFT_WR_Direction at TRISB2_bit;



sbit DriveX_Left at RA2_bit;
sbit DriveX_Right at RA0_bit;
sbit DriveY_Up at RA3_bit;
sbit DriveY_Down at RA1_bit;
sbit DriveX_Left_Direction at TRISA2_bit;
sbit DriveX_Right_Direction at TRISA0_bit;
sbit DriveY_Up_Direction at TRISA3_bit;
sbit DriveY_Down_Direction at TRISA1_bit;



unsigned int Xcoord, Ycoord;
const ADC_THRESHOLD = 900;
char PenDown;
void *PressedObject;
int PressedObjectType;
unsigned int caption_length, caption_height;
unsigned int display_width, display_height;

int i;
unsigned short object_pressed;
TButton *local_button;
TButton *exec_button;
short button_order;
TLabel *local_label;
TLabel *exec_label;
short label_order;

void Init_ADC() {
 Delay_ms(150);
 ADCON0 = 0x00;
 ADCON1 = 0x0B;
 ADC_Init();
 CMCON = 0b00000111;
 TRISC = 0b00000101;
 TRISE = 0b00000101;
 PORTC = 0;
 PORTE = 0;
}

static void InitializeTouchPanel() {
 Init_ADC();
 TFT_Init(320, 240);

 TP_TFT_Init(320, 240, 0, 1);
 TP_TFT_Set_ADC_Threshold(ADC_THRESHOLD);

 PenDown = 0;
 PressedObject = 0;
 PressedObjectType = -1;
}



 TScreen* CurrentScreen;

 TScreen Screen1;
 TLabel Label1;
char Label1_Caption[15] = "X10 CONTROLLER";

 TLabel Label2;
char Label2_Caption[5] = "CHAN";

 TButton Button1;
char Button1_Caption[7] = "Chan 1";

 TButton Button2;
char Button2_Caption[7] = "Liv Rm";

 TButton Button3;
char Button3_Caption[9] = "Chr Tree";

 TButton Button4;
char Button4_Caption[6] = "Kitch";

 TButton Button5;
char Button5_Caption[7] = "Mst BR";

 TButton Button6;
char Button6_Caption[5] = "Bath";

 TButton Button7;
char Button7_Caption[8] = "Hall Lt";

 TButton Button8;
char Button8_Caption[7] = "MB Fan";

 TButton Button17;
char Button17_Caption[3] = "ON";

 TButton Button18;
char Button18_Caption[4] = "OFF";

 TButton Button19;
char Button19_Caption[5] = "Next";

 TLabel Label5;
char Label5_Caption[5] = "1";

 TLabel Label6;
char Label6_Caption[5] = "";

 TButton * const code Screen1_Buttons[11]=
 {
 &Button1,
 &Button2,
 &Button3,
 &Button4,
 &Button5,
 &Button6,
 &Button7,
 &Button8,
 &Button17,
 &Button18,
 &Button19
 };
 TLabel * const code Screen1_Labels[4]=
 {
 &Label1,
 &Label2,
 &Label5,
 &Label6
 };


 TScreen Screen2;
 TLabel Label3;
char Label3_Caption[15] = "X10 CONTROLLER";

 TLabel Label4;
char Label4_Caption[5] = "CHAN";

 TButton Button9;
char Button9_Caption[6] = "Porch";

 TButton Button10;
char Button10_Caption[9] = "Piano Rm";

 TButton Button11;
char Button11_Caption[9] = "Pond Lts";

 TButton Button12;
char Button12_Caption[8] = "Chan 12";

 TButton Button13;
char Button13_Caption[5] = "Pond";

 TButton Button14;
char Button14_Caption[7] = "Din Rm";

 TButton Button15;
char Button15_Caption[7] = "Coffee";

 TButton Button16;
char Button16_Caption[8] = "Chan 16";

 TButton Button24;
char Button24_Caption[3] = "ON";

 TButton Button25;
char Button25_Caption[4] = "OFF";

 TButton Button22;
char Button22_Caption[5] = "Back";

 TLabel Label7;
char Label7_Caption[5] = "";

 TLabel Label8;
char Label8_Caption[7] = "";

 TButton * const code Screen2_Buttons[11]=
 {
 &Button9,
 &Button10,
 &Button11,
 &Button12,
 &Button13,
 &Button14,
 &Button15,
 &Button16,
 &Button24,
 &Button25,
 &Button22
 };
 TLabel * const code Screen2_Labels[4]=
 {
 &Label3,
 &Label4,
 &Label7,
 &Label8
 };




static void InitializeObjects() {
 Screen1.Color = 0x0000;
 Screen1.Width = 320;
 Screen1.Height = 240;
 Screen1.ButtonsCount = 11;
 Screen1.Buttons = Screen1_Buttons;
 Screen1.LabelsCount = 4;
 Screen1.Labels = Screen1_Labels;
 Screen1.ObjectsCount = 15;

 Screen2.Color = 0x0000;
 Screen2.Width = 320;
 Screen2.Height = 240;
 Screen2.ButtonsCount = 11;
 Screen2.Buttons = Screen2_Buttons;
 Screen2.LabelsCount = 4;
 Screen2.Labels = Screen2_Labels;
 Screen2.ObjectsCount = 15;


 Label1.OwnerScreen = &Screen1;
 Label1.Order = 0;
 Label1.Left = 5;
 Label1.Top = 5;
 Label1.Width = 145;
 Label1.Height = 18;
 Label1.Visible = 1;
 Label1.Active = 1;
 Label1.Caption = Label1_Caption;
 Label1.FontName = Tahoma19x19_Bold;
 Label1.Font_Color = 0x001F;
 Label1.OnUpPtr = 0;
 Label1.OnDownPtr = 0;
 Label1.OnClickPtr = 0;
 Label1.OnPressPtr = 0;

 Label2.OwnerScreen = &Screen1;
 Label2.Order = 1;
 Label2.Left = 120;
 Label2.Top = 26;
 Label2.Width = 51;
 Label2.Height = 18;
 Label2.Visible = 1;
 Label2.Active = 1;
 Label2.Caption = Label2_Caption;
 Label2.FontName = Tahoma19x19_Bold;
 Label2.Font_Color = 0xFFFF;
 Label2.OnUpPtr = 0;
 Label2.OnDownPtr = 0;
 Label2.OnClickPtr = 0;
 Label2.OnPressPtr = 0;

 Button1.OwnerScreen = &Screen1;
 Button1.Order = 2;
 Button1.Left = 4;
 Button1.Top = 44;
 Button1.Width = 75;
 Button1.Height = 55;
 Button1.Pen_Width = 1;
 Button1.Pen_Color = 0x0000;
 Button1.Visible = 1;
 Button1.Active = 1;
 Button1.Transparent = 1;
 Button1.Caption = Button1_Caption;
 Button1.FontName = Tahoma19x19_Bold;
 Button1.PressColEnabled = 1;
 Button1.Font_Color = 0x0000;
 Button1.Gradient = 0;
 Button1.Gradient_Orientation = 0;
 Button1.Gradient_Start_Color = 0xFFFF;
 Button1.Gradient_End_Color = 0x001F;
 Button1.Color = 0xFC00;
 Button1.PressColEnabled = 1;
 Button1.Press_Color = 0xC618;
 Button1.OnUpPtr = 0;
 Button1.OnDownPtr = Button1Down;
 Button1.OnClickPtr = 0;
 Button1.OnPressPtr = 0;

 Button2.OwnerScreen = &Screen1;
 Button2.Order = 3;
 Button2.Left = 82;
 Button2.Top = 44;
 Button2.Width = 75;
 Button2.Height = 55;
 Button2.Pen_Width = 1;
 Button2.Pen_Color = 0x0000;
 Button2.Visible = 1;
 Button2.Active = 1;
 Button2.Transparent = 1;
 Button2.Caption = Button2_Caption;
 Button2.FontName = Tahoma19x19_Bold;
 Button2.PressColEnabled = 1;
 Button2.Font_Color = 0x0000;
 Button2.Gradient = 0;
 Button2.Gradient_Orientation = 0;
 Button2.Gradient_Start_Color = 0xFFFF;
 Button2.Gradient_End_Color = 0x001F;
 Button2.Color = 0xFC00;
 Button2.PressColEnabled = 1;
 Button2.Press_Color = 0xC618;
 Button2.OnUpPtr = 0;
 Button2.OnDownPtr = Button2Down;
 Button2.OnClickPtr = 0;
 Button2.OnPressPtr = 0;

 Button3.OwnerScreen = &Screen1;
 Button3.Order = 4;
 Button3.Left = 160;
 Button3.Top = 44;
 Button3.Width = 75;
 Button3.Height = 55;
 Button3.Pen_Width = 1;
 Button3.Pen_Color = 0x0000;
 Button3.Visible = 1;
 Button3.Active = 1;
 Button3.Transparent = 1;
 Button3.Caption = Button3_Caption;
 Button3.FontName = Tahoma19x19_Bold;
 Button3.PressColEnabled = 1;
 Button3.Font_Color = 0x0000;
 Button3.Gradient = 0;
 Button3.Gradient_Orientation = 0;
 Button3.Gradient_Start_Color = 0xFFFF;
 Button3.Gradient_End_Color = 0x001F;
 Button3.Color = 0xFC00;
 Button3.PressColEnabled = 1;
 Button3.Press_Color = 0xC618;
 Button3.OnUpPtr = 0;
 Button3.OnDownPtr = Button3Down;
 Button3.OnClickPtr = 0;
 Button3.OnPressPtr = 0;

 Button4.OwnerScreen = &Screen1;
 Button4.Order = 5;
 Button4.Left = 238;
 Button4.Top = 44;
 Button4.Width = 75;
 Button4.Height = 55;
 Button4.Pen_Width = 1;
 Button4.Pen_Color = 0x0000;
 Button4.Visible = 1;
 Button4.Active = 1;
 Button4.Transparent = 1;
 Button4.Caption = Button4_Caption;
 Button4.FontName = Tahoma19x19_Bold;
 Button4.PressColEnabled = 1;
 Button4.Font_Color = 0x0000;
 Button4.Gradient = 0;
 Button4.Gradient_Orientation = 0;
 Button4.Gradient_Start_Color = 0xFFFF;
 Button4.Gradient_End_Color = 0x001F;
 Button4.Color = 0xFC00;
 Button4.PressColEnabled = 1;
 Button4.Press_Color = 0xC618;
 Button4.OnUpPtr = 0;
 Button4.OnDownPtr = Button4Down;
 Button4.OnClickPtr = 0;
 Button4.OnPressPtr = 0;

 Button5.OwnerScreen = &Screen1;
 Button5.Order = 6;
 Button5.Left = 4;
 Button5.Top = 103;
 Button5.Width = 75;
 Button5.Height = 55;
 Button5.Pen_Width = 1;
 Button5.Pen_Color = 0x0000;
 Button5.Visible = 1;
 Button5.Active = 1;
 Button5.Transparent = 1;
 Button5.Caption = Button5_Caption;
 Button5.FontName = Tahoma19x19_Bold;
 Button5.PressColEnabled = 1;
 Button5.Font_Color = 0x0000;
 Button5.Gradient = 0;
 Button5.Gradient_Orientation = 0;
 Button5.Gradient_Start_Color = 0xFFFF;
 Button5.Gradient_End_Color = 0x001F;
 Button5.Color = 0xFC00;
 Button5.PressColEnabled = 1;
 Button5.Press_Color = 0xC618;
 Button5.OnUpPtr = 0;
 Button5.OnDownPtr = Button5Down;
 Button5.OnClickPtr = 0;
 Button5.OnPressPtr = 0;

 Button6.OwnerScreen = &Screen1;
 Button6.Order = 7;
 Button6.Left = 82;
 Button6.Top = 103;
 Button6.Width = 75;
 Button6.Height = 55;
 Button6.Pen_Width = 1;
 Button6.Pen_Color = 0x0000;
 Button6.Visible = 1;
 Button6.Active = 1;
 Button6.Transparent = 1;
 Button6.Caption = Button6_Caption;
 Button6.FontName = Tahoma19x19_Bold;
 Button6.PressColEnabled = 1;
 Button6.Font_Color = 0x0000;
 Button6.Gradient = 0;
 Button6.Gradient_Orientation = 0;
 Button6.Gradient_Start_Color = 0xFFFF;
 Button6.Gradient_End_Color = 0x001F;
 Button6.Color = 0xFC00;
 Button6.PressColEnabled = 1;
 Button6.Press_Color = 0xC618;
 Button6.OnUpPtr = 0;
 Button6.OnDownPtr = Button6Down;
 Button6.OnClickPtr = 0;
 Button6.OnPressPtr = 0;

 Button7.OwnerScreen = &Screen1;
 Button7.Order = 8;
 Button7.Left = 160;
 Button7.Top = 103;
 Button7.Width = 75;
 Button7.Height = 55;
 Button7.Pen_Width = 1;
 Button7.Pen_Color = 0x0000;
 Button7.Visible = 1;
 Button7.Active = 1;
 Button7.Transparent = 1;
 Button7.Caption = Button7_Caption;
 Button7.FontName = Tahoma19x19_Bold;
 Button7.PressColEnabled = 1;
 Button7.Font_Color = 0x0000;
 Button7.Gradient = 0;
 Button7.Gradient_Orientation = 0;
 Button7.Gradient_Start_Color = 0xFFFF;
 Button7.Gradient_End_Color = 0x001F;
 Button7.Color = 0xFC00;
 Button7.PressColEnabled = 1;
 Button7.Press_Color = 0xC618;
 Button7.OnUpPtr = 0;
 Button7.OnDownPtr = Button7Down;
 Button7.OnClickPtr = 0;
 Button7.OnPressPtr = 0;

 Button8.OwnerScreen = &Screen1;
 Button8.Order = 9;
 Button8.Left = 238;
 Button8.Top = 103;
 Button8.Width = 75;
 Button8.Height = 55;
 Button8.Pen_Width = 1;
 Button8.Pen_Color = 0x0000;
 Button8.Visible = 1;
 Button8.Active = 1;
 Button8.Transparent = 1;
 Button8.Caption = Button8_Caption;
 Button8.FontName = Tahoma19x19_Bold;
 Button8.PressColEnabled = 1;
 Button8.Font_Color = 0x0000;
 Button8.Gradient = 0;
 Button8.Gradient_Orientation = 0;
 Button8.Gradient_Start_Color = 0xFFFF;
 Button8.Gradient_End_Color = 0x001F;
 Button8.Color = 0xFC00;
 Button8.PressColEnabled = 1;
 Button8.Press_Color = 0xC618;
 Button8.OnUpPtr = 0;
 Button8.OnDownPtr = Button8Down;
 Button8.OnClickPtr = 0;
 Button8.OnPressPtr = 0;

 Button17.OwnerScreen = &Screen1;
 Button17.Order = 10;
 Button17.Left = 82;
 Button17.Top = 162;
 Button17.Width = 75;
 Button17.Height = 55;
 Button17.Pen_Width = 1;
 Button17.Pen_Color = 0x0000;
 Button17.Visible = 1;
 Button17.Active = 1;
 Button17.Transparent = 1;
 Button17.Caption = Button17_Caption;
 Button17.FontName = Tahoma19x19_Bold;
 Button17.PressColEnabled = 1;
 Button17.Font_Color = 0x0000;
 Button17.Gradient = 0;
 Button17.Gradient_Orientation = 0;
 Button17.Gradient_Start_Color = 0xFFFF;
 Button17.Gradient_End_Color = 0x001F;
 Button17.Color = 0x07E0;
 Button17.PressColEnabled = 1;
 Button17.Press_Color = 0xC618;
 Button17.OnUpPtr = 0;
 Button17.OnDownPtr = Button17Down;
 Button17.OnClickPtr = 0;
 Button17.OnPressPtr = 0;

 Button18.OwnerScreen = &Screen1;
 Button18.Order = 11;
 Button18.Left = 160;
 Button18.Top = 162;
 Button18.Width = 75;
 Button18.Height = 55;
 Button18.Pen_Width = 1;
 Button18.Pen_Color = 0x0000;
 Button18.Visible = 1;
 Button18.Active = 1;
 Button18.Transparent = 1;
 Button18.Caption = Button18_Caption;
 Button18.FontName = Tahoma19x19_Bold;
 Button18.PressColEnabled = 1;
 Button18.Font_Color = 0x0000;
 Button18.Gradient = 0;
 Button18.Gradient_Orientation = 0;
 Button18.Gradient_Start_Color = 0xFFFF;
 Button18.Gradient_End_Color = 0x001F;
 Button18.Color = 0xF800;
 Button18.PressColEnabled = 1;
 Button18.Press_Color = 0xC618;
 Button18.OnUpPtr = 0;
 Button18.OnDownPtr = Button18Down;
 Button18.OnClickPtr = 0;
 Button18.OnPressPtr = 0;

 Button19.OwnerScreen = &Screen1;
 Button19.Order = 12;
 Button19.Left = 238;
 Button19.Top = 162;
 Button19.Width = 75;
 Button19.Height = 55;
 Button19.Pen_Width = 1;
 Button19.Pen_Color = 0x0000;
 Button19.Visible = 1;
 Button19.Active = 1;
 Button19.Transparent = 1;
 Button19.Caption = Button19_Caption;
 Button19.FontName = Tahoma19x19_Bold;
 Button19.PressColEnabled = 1;
 Button19.Font_Color = 0x0000;
 Button19.Gradient = 0;
 Button19.Gradient_Orientation = 0;
 Button19.Gradient_Start_Color = 0xFFFF;
 Button19.Gradient_End_Color = 0x001F;
 Button19.Color = 0x8410;
 Button19.PressColEnabled = 1;
 Button19.Press_Color = 0xC618;
 Button19.OnUpPtr = 0;
 Button19.OnDownPtr = Button19Down;
 Button19.OnClickPtr = 0;
 Button19.OnPressPtr = 0;

 Label5.OwnerScreen = &Screen1;
 Label5.Order = 13;
 Label5.Left = 180;
 Label5.Top = 26;
 Label5.Width = 41;
 Label5.Height = 18;
 Label5.Visible = 1;
 Label5.Active = 1;
 Label5.Caption = Label5_Caption;
 Label5.FontName = Tahoma19x19_Bold;
 Label5.Font_Color = 0xFFFF;
 Label5.OnUpPtr = 0;
 Label5.OnDownPtr = 0;
 Label5.OnClickPtr = 0;
 Label5.OnPressPtr = 0;

 Label6.OwnerScreen = &Screen1;
 Label6.Order = 14;
 Label6.Left = 240;
 Label6.Top = 26;
 Label6.Width = 41;
 Label6.Height = 18;
 Label6.Visible = 1;
 Label6.Active = 1;
 Label6.Caption = Label6_Caption;
 Label6.FontName = Tahoma19x19_Bold;
 Label6.Font_Color = 0xFFFF;
 Label6.OnUpPtr = 0;
 Label6.OnDownPtr = 0;
 Label6.OnClickPtr = 0;
 Label6.OnPressPtr = 0;

 Label3.OwnerScreen = &Screen2;
 Label3.Order = 0;
 Label3.Left = 4;
 Label3.Top = 4;
 Label3.Width = 145;
 Label3.Height = 18;
 Label3.Visible = 1;
 Label3.Active = 1;
 Label3.Caption = Label3_Caption;
 Label3.FontName = Tahoma19x19_Bold;
 Label3.Font_Color = 0x001F;
 Label3.OnUpPtr = 0;
 Label3.OnDownPtr = 0;
 Label3.OnClickPtr = 0;
 Label3.OnPressPtr = 0;

 Label4.OwnerScreen = &Screen2;
 Label4.Order = 1;
 Label4.Left = 120;
 Label4.Top = 25;
 Label4.Width = 51;
 Label4.Height = 18;
 Label4.Visible = 1;
 Label4.Active = 1;
 Label4.Caption = Label4_Caption;
 Label4.FontName = Tahoma19x19_Bold;
 Label4.Font_Color = 0xFFFF;
 Label4.OnUpPtr = 0;
 Label4.OnDownPtr = 0;
 Label4.OnClickPtr = 0;
 Label4.OnPressPtr = 0;

 Button9.OwnerScreen = &Screen2;
 Button9.Order = 2;
 Button9.Left = 4;
 Button9.Top = 44;
 Button9.Width = 75;
 Button9.Height = 55;
 Button9.Pen_Width = 1;
 Button9.Pen_Color = 0x0000;
 Button9.Visible = 1;
 Button9.Active = 1;
 Button9.Transparent = 1;
 Button9.Caption = Button9_Caption;
 Button9.FontName = Tahoma19x19_Bold;
 Button9.PressColEnabled = 1;
 Button9.Font_Color = 0x0000;
 Button9.Gradient = 0;
 Button9.Gradient_Orientation = 0;
 Button9.Gradient_Start_Color = 0xFFFF;
 Button9.Gradient_End_Color = 0x001F;
 Button9.Color = 0xFC00;
 Button9.PressColEnabled = 1;
 Button9.Press_Color = 0xC618;
 Button9.OnUpPtr = 0;
 Button9.OnDownPtr = Button9Down;
 Button9.OnClickPtr = 0;
 Button9.OnPressPtr = 0;

 Button10.OwnerScreen = &Screen2;
 Button10.Order = 3;
 Button10.Left = 82;
 Button10.Top = 44;
 Button10.Width = 75;
 Button10.Height = 55;
 Button10.Pen_Width = 1;
 Button10.Pen_Color = 0x0000;
 Button10.Visible = 1;
 Button10.Active = 1;
 Button10.Transparent = 1;
 Button10.Caption = Button10_Caption;
 Button10.FontName = Tahoma18x18_Bold;
 Button10.PressColEnabled = 1;
 Button10.Font_Color = 0x0000;
 Button10.Gradient = 0;
 Button10.Gradient_Orientation = 0;
 Button10.Gradient_Start_Color = 0xFFFF;
 Button10.Gradient_End_Color = 0x001F;
 Button10.Color = 0xFC00;
 Button10.PressColEnabled = 1;
 Button10.Press_Color = 0xC618;
 Button10.OnUpPtr = 0;
 Button10.OnDownPtr = Button10Down;
 Button10.OnClickPtr = 0;
 Button10.OnPressPtr = 0;

 Button11.OwnerScreen = &Screen2;
 Button11.Order = 4;
 Button11.Left = 160;
 Button11.Top = 44;
 Button11.Width = 75;
 Button11.Height = 55;
 Button11.Pen_Width = 1;
 Button11.Pen_Color = 0x0000;
 Button11.Visible = 1;
 Button11.Active = 1;
 Button11.Transparent = 1;
 Button11.Caption = Button11_Caption;
 Button11.FontName = Tahoma19x19_Bold;
 Button11.PressColEnabled = 1;
 Button11.Font_Color = 0x0000;
 Button11.Gradient = 0;
 Button11.Gradient_Orientation = 0;
 Button11.Gradient_Start_Color = 0xFFFF;
 Button11.Gradient_End_Color = 0x001F;
 Button11.Color = 0xFC00;
 Button11.PressColEnabled = 1;
 Button11.Press_Color = 0xC618;
 Button11.OnUpPtr = 0;
 Button11.OnDownPtr = Button11Down;
 Button11.OnClickPtr = 0;
 Button11.OnPressPtr = 0;

 Button12.OwnerScreen = &Screen2;
 Button12.Order = 5;
 Button12.Left = 238;
 Button12.Top = 44;
 Button12.Width = 75;
 Button12.Height = 55;
 Button12.Pen_Width = 1;
 Button12.Pen_Color = 0x0000;
 Button12.Visible = 1;
 Button12.Active = 1;
 Button12.Transparent = 1;
 Button12.Caption = Button12_Caption;
 Button12.FontName = Tahoma19x19_Bold;
 Button12.PressColEnabled = 1;
 Button12.Font_Color = 0x0000;
 Button12.Gradient = 0;
 Button12.Gradient_Orientation = 0;
 Button12.Gradient_Start_Color = 0xFFFF;
 Button12.Gradient_End_Color = 0x001F;
 Button12.Color = 0xFC00;
 Button12.PressColEnabled = 1;
 Button12.Press_Color = 0xC618;
 Button12.OnUpPtr = 0;
 Button12.OnDownPtr = Button12Down;
 Button12.OnClickPtr = 0;
 Button12.OnPressPtr = 0;

 Button13.OwnerScreen = &Screen2;
 Button13.Order = 6;
 Button13.Left = 4;
 Button13.Top = 103;
 Button13.Width = 75;
 Button13.Height = 55;
 Button13.Pen_Width = 1;
 Button13.Pen_Color = 0x0000;
 Button13.Visible = 1;
 Button13.Active = 1;
 Button13.Transparent = 1;
 Button13.Caption = Button13_Caption;
 Button13.FontName = Tahoma19x19_Bold;
 Button13.PressColEnabled = 1;
 Button13.Font_Color = 0x0000;
 Button13.Gradient = 0;
 Button13.Gradient_Orientation = 0;
 Button13.Gradient_Start_Color = 0xFFFF;
 Button13.Gradient_End_Color = 0x001F;
 Button13.Color = 0xFC00;
 Button13.PressColEnabled = 1;
 Button13.Press_Color = 0xC618;
 Button13.OnUpPtr = 0;
 Button13.OnDownPtr = Button13Down;
 Button13.OnClickPtr = 0;
 Button13.OnPressPtr = 0;

 Button14.OwnerScreen = &Screen2;
 Button14.Order = 7;
 Button14.Left = 82;
 Button14.Top = 103;
 Button14.Width = 75;
 Button14.Height = 55;
 Button14.Pen_Width = 1;
 Button14.Pen_Color = 0x0000;
 Button14.Visible = 1;
 Button14.Active = 1;
 Button14.Transparent = 1;
 Button14.Caption = Button14_Caption;
 Button14.FontName = Tahoma19x19_Bold;
 Button14.PressColEnabled = 1;
 Button14.Font_Color = 0x0000;
 Button14.Gradient = 0;
 Button14.Gradient_Orientation = 0;
 Button14.Gradient_Start_Color = 0xFFFF;
 Button14.Gradient_End_Color = 0x001F;
 Button14.Color = 0xFC00;
 Button14.PressColEnabled = 1;
 Button14.Press_Color = 0xC618;
 Button14.OnUpPtr = 0;
 Button14.OnDownPtr = Button14Down;
 Button14.OnClickPtr = 0;
 Button14.OnPressPtr = 0;

 Button15.OwnerScreen = &Screen2;
 Button15.Order = 8;
 Button15.Left = 160;
 Button15.Top = 103;
 Button15.Width = 75;
 Button15.Height = 55;
 Button15.Pen_Width = 1;
 Button15.Pen_Color = 0x0000;
 Button15.Visible = 1;
 Button15.Active = 1;
 Button15.Transparent = 1;
 Button15.Caption = Button15_Caption;
 Button15.FontName = Tahoma19x19_Bold;
 Button15.PressColEnabled = 1;
 Button15.Font_Color = 0x0000;
 Button15.Gradient = 0;
 Button15.Gradient_Orientation = 0;
 Button15.Gradient_Start_Color = 0xFFFF;
 Button15.Gradient_End_Color = 0x001F;
 Button15.Color = 0xFC00;
 Button15.PressColEnabled = 1;
 Button15.Press_Color = 0xC618;
 Button15.OnUpPtr = 0;
 Button15.OnDownPtr = Button15Down;
 Button15.OnClickPtr = 0;
 Button15.OnPressPtr = 0;

 Button16.OwnerScreen = &Screen2;
 Button16.Order = 9;
 Button16.Left = 238;
 Button16.Top = 103;
 Button16.Width = 75;
 Button16.Height = 55;
 Button16.Pen_Width = 1;
 Button16.Pen_Color = 0x0000;
 Button16.Visible = 1;
 Button16.Active = 1;
 Button16.Transparent = 1;
 Button16.Caption = Button16_Caption;
 Button16.FontName = Tahoma19x19_Bold;
 Button16.PressColEnabled = 1;
 Button16.Font_Color = 0x0000;
 Button16.Gradient = 0;
 Button16.Gradient_Orientation = 0;
 Button16.Gradient_Start_Color = 0xFFFF;
 Button16.Gradient_End_Color = 0x001F;
 Button16.Color = 0xFC00;
 Button16.PressColEnabled = 1;
 Button16.Press_Color = 0xC618;
 Button16.OnUpPtr = 0;
 Button16.OnDownPtr = Button16Down;
 Button16.OnClickPtr = 0;
 Button16.OnPressPtr = 0;

 Button24.OwnerScreen = &Screen2;
 Button24.Order = 10;
 Button24.Left = 82;
 Button24.Top = 162;
 Button24.Width = 75;
 Button24.Height = 55;
 Button24.Pen_Width = 1;
 Button24.Pen_Color = 0x0000;
 Button24.Visible = 1;
 Button24.Active = 1;
 Button24.Transparent = 1;
 Button24.Caption = Button24_Caption;
 Button24.FontName = Tahoma19x19_Bold;
 Button24.PressColEnabled = 1;
 Button24.Font_Color = 0x0000;
 Button24.Gradient = 0;
 Button24.Gradient_Orientation = 0;
 Button24.Gradient_Start_Color = 0xFFFF;
 Button24.Gradient_End_Color = 0x001F;
 Button24.Color = 0x07E0;
 Button24.PressColEnabled = 1;
 Button24.Press_Color = 0xC618;
 Button24.OnUpPtr = 0;
 Button24.OnDownPtr = Button24Down;
 Button24.OnClickPtr = 0;
 Button24.OnPressPtr = 0;

 Button25.OwnerScreen = &Screen2;
 Button25.Order = 11;
 Button25.Left = 160;
 Button25.Top = 162;
 Button25.Width = 75;
 Button25.Height = 55;
 Button25.Pen_Width = 1;
 Button25.Pen_Color = 0x0000;
 Button25.Visible = 1;
 Button25.Active = 1;
 Button25.Transparent = 1;
 Button25.Caption = Button25_Caption;
 Button25.FontName = Tahoma19x19_Bold;
 Button25.PressColEnabled = 1;
 Button25.Font_Color = 0x0000;
 Button25.Gradient = 0;
 Button25.Gradient_Orientation = 0;
 Button25.Gradient_Start_Color = 0xFFFF;
 Button25.Gradient_End_Color = 0x001F;
 Button25.Color = 0xF800;
 Button25.PressColEnabled = 1;
 Button25.Press_Color = 0xC618;
 Button25.OnUpPtr = 0;
 Button25.OnDownPtr = Button25Down;
 Button25.OnClickPtr = 0;
 Button25.OnPressPtr = 0;

 Button22.OwnerScreen = &Screen2;
 Button22.Order = 12;
 Button22.Left = 4;
 Button22.Top = 162;
 Button22.Width = 75;
 Button22.Height = 55;
 Button22.Pen_Width = 1;
 Button22.Pen_Color = 0x0000;
 Button22.Visible = 1;
 Button22.Active = 1;
 Button22.Transparent = 1;
 Button22.Caption = Button22_Caption;
 Button22.FontName = Tahoma19x19_Bold;
 Button22.PressColEnabled = 1;
 Button22.Font_Color = 0x0000;
 Button22.Gradient = 0;
 Button22.Gradient_Orientation = 0;
 Button22.Gradient_Start_Color = 0xFFFF;
 Button22.Gradient_End_Color = 0x001F;
 Button22.Color = 0x8410;
 Button22.PressColEnabled = 1;
 Button22.Press_Color = 0xC618;
 Button22.OnUpPtr = 0;
 Button22.OnDownPtr = Button22Down;
 Button22.OnClickPtr = 0;
 Button22.OnPressPtr = 0;

 Label7.OwnerScreen = &Screen2;
 Label7.Order = 13;
 Label7.Left = 180;
 Label7.Top = 25;
 Label7.Width = 41;
 Label7.Height = 18;
 Label7.Visible = 1;
 Label7.Active = 1;
 Label7.Caption = Label7_Caption;
 Label7.FontName = Tahoma19x19_Bold;
 Label7.Font_Color = 0xFFFF;
 Label7.OnUpPtr = 0;
 Label7.OnDownPtr = 0;
 Label7.OnClickPtr = 0;
 Label7.OnPressPtr = 0;

 Label8.OwnerScreen = &Screen2;
 Label8.Order = 14;
 Label8.Left = 250;
 Label8.Top = 25;
 Label8.Width = 41;
 Label8.Height = 18;
 Label8.Visible = 1;
 Label8.Active = 1;
 Label8.Caption = Label8_Caption;
 Label8.FontName = Tahoma19x19_Bold;
 Label8.Font_Color = 0xFFFF;
 Label8.OnUpPtr = 0;
 Label8.OnDownPtr = 0;
 Label8.OnClickPtr = 0;
 Label8.OnPressPtr = 0;
}

static char IsInsideObject (unsigned int X, unsigned int Y, unsigned int Left, unsigned int Top, unsigned int Width, unsigned int Height) {
 if ( (Left<= X) && (Left+ Width - 1 >= X) &&
 (Top <= Y) && (Top + Height - 1 >= Y) )
 return 1;
 else
 return 0;
}






void DrawButton(TButton *Abutton) {
 if (Abutton->Visible == 1) {
 if (object_pressed == 1) {
 object_pressed = 0;
 TFT_Set_Brush(Abutton->Transparent, Abutton->Color, Abutton->Gradient, Abutton->Gradient_Orientation, Abutton->Gradient_End_Color, Abutton->Gradient_Start_Color);
 }
 else {
 TFT_Set_Brush(Abutton->Transparent, Abutton->Color, Abutton->Gradient, Abutton->Gradient_Orientation, Abutton->Gradient_Start_Color, Abutton->Gradient_End_Color);
 }
 TFT_Set_Pen(Abutton->Pen_Color, Abutton->Pen_Width);
 TFT_Rectangle(Abutton->Left, Abutton->Top, Abutton->Left + Abutton->Width - 1, Abutton->Top + Abutton->Height - 1);
 TFT_Set_Font(Abutton->FontName, Abutton->Font_Color, FO_HORIZONTAL);
 TFT_Write_Text_Return_Pos(Abutton->Caption, Abutton->Left, Abutton->Top);
 TFT_Write_Text(Abutton->Caption, (Abutton->Left + ((Abutton->Width - caption_length) / 2)), (Abutton->Top + ((Abutton->Height - caption_height) / 2)));
 }
}

void DrawLabel(TLabel *ALabel)
{
int x_pos, y_pos;
 x_pos = 0;
 y_pos = 0;
 if (ALabel->Visible == 1)
 {
 TFT_Set_Font(ALabel->FontName, ALabel->Font_Color, FO_HORIZONTAL);
 TFT_Write_Text_Return_Pos(ALabel->Caption, ALabel->Left, ALabel->Top);
 x_pos = ALabel->Left + ((int)(ALabel->Width - caption_length) / 2);
 y_pos = ALabel->Top + ((int)(ALabel->Height - caption_height) / 2);
 if ((x_pos >= 0) && (y_pos >= 0))
 {
 TFT_Write_Text(ALabel->Caption, x_pos, y_pos);
 }
 else
 {
 TFT_Write_Text(ALabel->Caption, ALabel->Left, ALabel->Top);
 }
 }
}

void DrawScreen(TScreen *aScreen) {
 unsigned short order;
 unsigned short button_idx;
 TButton *local_button;
 unsigned short label_idx;
 TLabel *local_label;
 char save_bled, save_bled_direction;

 order = 0;
 button_idx = 0;
 label_idx = 0;
 CurrentScreen = aScreen;

 if ((display_width != CurrentScreen->Width) || (display_height != CurrentScreen->Height)) {
 save_bled = TFT_BLED;
 save_bled_direction = TFT_BLED_Direction;
 TFT_BLED_Direction = 0;
 TFT_BLED = 0;
 TFT_Init(CurrentScreen->Width, CurrentScreen->Height);
 TP_TFT_Init(CurrentScreen->Width, CurrentScreen->Height, 0, 1);
 TP_TFT_Set_ADC_Threshold(ADC_THRESHOLD);
 TFT_Fill_Screen(CurrentScreen->Color);
 display_width = CurrentScreen->Width;
 display_height = CurrentScreen->Height;
 TFT_BLED = save_bled;
 TFT_BLED_Direction = save_bled_direction;
 }
 else
 TFT_Fill_Screen(CurrentScreen->Color);

 CurrentScreen = aScreen;

 while (order < CurrentScreen->ObjectsCount) {
 if (button_idx < CurrentScreen->ButtonsCount) {
 local_button =  CurrentScreen->Buttons[button_idx] ;
 if (order == local_button->Order) {
 button_idx++;
 order++;
 DrawButton(local_button);
 }
 }

 if (label_idx < CurrentScreen->LabelsCount) {
 local_label =  CurrentScreen->Labels[label_idx] ;
 if (order == local_label->Order) {
 label_idx++;
 order++;
 DrawLabel(local_label);
 }
 }

 }
}

void Get_Object(unsigned int X, unsigned int Y) {
 button_order = -1;
 label_order = -1;

 for ( i = 0 ; i < CurrentScreen->ButtonsCount ; i++ ) {
 local_button =  CurrentScreen->Buttons[i] ;
 if (local_button->Active == 1) {
 if (IsInsideObject(X, Y, local_button->Left, local_button->Top,
 local_button->Width, local_button->Height) == 1) {
 button_order = local_button->Order;
 exec_button = local_button;
 }
 }
 }


 for ( i = 0 ; i < CurrentScreen->LabelsCount ; i++ ) {
 local_label =  CurrentScreen->Labels[i] ;
 if (local_label->Active == 1) {
 if (IsInsideObject(X, Y, local_label->Left, local_label->Top,
 local_label->Width, local_label->Height) == 1) {
 label_order = local_label->Order;
 exec_label = local_label;
 }
 }
 }

 i = -1;
 if (button_order > i)
 i = button_order;
 if (label_order > i)
 i = label_order;
}


static void Process_TP_Press(unsigned int X, unsigned int Y) {
 exec_button = 0;
 exec_label = 0;

 Get_Object(X, Y);


 if (i != -1) {
 if (i == button_order) {
 if (exec_button->Active == 1) {
 if (exec_button->OnPressPtr != 0) {
 exec_button->OnPressPtr();
 return;
 }
 }
 }

 if (i == label_order) {
 if (exec_label->Active == 1) {
 if (exec_label->OnPressPtr != 0) {
 exec_label->OnPressPtr();
 return;
 }
 }
 }

 }
}

static void Process_TP_Up(unsigned int X, unsigned int Y) {

 switch (PressedObjectType) {

 case 0: {
 if (PressedObject != 0) {
 exec_button = (TButton*)PressedObject;
 if ((exec_button->PressColEnabled == 1) && (exec_button->OwnerScreen == CurrentScreen)) {
 DrawButton(exec_button);
 }
 break;
 }
 break;
 }
 }

 exec_label = 0;

 Get_Object(X, Y);


 if (i != -1) {

 if (i == button_order) {
 if (exec_button->Active == 1) {
 if (exec_button->OnUpPtr != 0)
 exec_button->OnUpPtr();
 if (PressedObject == (void *)exec_button)
 if (exec_button->OnClickPtr != 0)
 exec_button->OnClickPtr();
 PressedObject = 0;
 PressedObjectType = -1;
 return;
 }
 }


 if (i == label_order) {
 if (exec_label->Active == 1) {
 if (exec_label->OnUpPtr != 0)
 exec_label->OnUpPtr();
 if (PressedObject == (void *)exec_label)
 if (exec_label->OnClickPtr != 0)
 exec_label->OnClickPtr();
 PressedObject = 0;
 PressedObjectType = -1;
 return;
 }
 }

 }
 PressedObject = 0;
 PressedObjectType = -1;
}

static void Process_TP_Down(unsigned int X, unsigned int Y) {

 object_pressed = 0;
 exec_button = 0;
 exec_label = 0;

 Get_Object(X, Y);

 if (i != -1) {
 if (i == button_order) {
 if (exec_button->Active == 1) {
 if (exec_button->PressColEnabled == 1) {
 object_pressed = 1;
 DrawButton(exec_button);
 }
 PressedObject = (void *)exec_button;
 PressedObjectType = 0;
 if (exec_button->OnDownPtr != 0) {
 exec_button->OnDownPtr();
 return;
 }
 }
 }

 if (i == label_order) {
 if (exec_label->Active == 1) {
 PressedObject = (void *)exec_label;
 PressedObjectType = 2;
 if (exec_label->OnDownPtr != 0) {
 exec_label->OnDownPtr();
 return;
 }
 }
 }

 }
}


void Check_TP()
{

 if (TP_TFT_Press_Detect())
 {

 if (TP_TFT_Get_Coordinates(&Xcoord, &Ycoord) == 0)
 {
 Process_TP_Press(Xcoord, Ycoord);
 if (PenDown == 0)
 {
 PenDown = 1;
 Process_TP_Down(Xcoord, Ycoord);
 }
 }

 else if (PenDown == 1)
 {
 PenDown = 0;
 Process_TP_Up(Xcoord, Ycoord);
 }
 }
}

void Button19Down() {
 display_width = Screen2.Width;
 display_height = Screen2.Height;
 DrawScreen(&Screen2);
}

void Button22Down() {
 display_width = Screen1.Width;
 display_height = Screen1.Height;
 DrawScreen(&Screen1);
}

void Start_TP()
{
 InitializeTouchPanel();



 InitializeObjects();
 display_width = Screen1.Width;
 display_height = Screen1.Height;
}
