//****************************************************************************
//  Project name:
//  X10_Color_Touch.mcppi
//  Uses TFT Touch Screen 320 x 240 to send X10 Command via PSC04 Interface
//  Touch Screen on PORTA
//  TFT on PORTB and PORTD
//  X10 PSC04 on PORTC
//  P18F4685 10Mhz Crystal,  HSPLL @ 40Mhz
//
//****************************************************************************
#include "X10_Color_Touch_objects.h"
#include "Eprom.h"
//unsigned int x_min, y_min, x_max, y_max; // Calibration constants
void Display_X10_TFT();
unsigned int x_coord, y_coord;
//****************************************************************************
void Calibrate() 
{
  TFT_Set_Pen(CL_WHITE, 3);
  TFT_Circle(314,5,5);
  
  Delay_ms(5000);
  TP_TFT_Calibrate_Min();                  // Calibration of Upper Right corner

  TFT_Fill_Screen(CL_OLIVE);
  TFT_Set_Pen(CL_WHITE, 3);                // WHITE
  TFT_Circle(5,234,5);

  Delay_ms(5000);
  TP_TFT_Calibrate_Max();                  // Calibration of Lower Left corner
  
  TP_TFT_Get_Calibration_Consts(&x_min, &x_max, &y_min, &y_max); 
}
//****************************************************************************
void main()
{
  Start_TP();
  Delay_ms(250);
  if (EEPROM_READ(8) == 34) goto skip;  // If dummy value set, skip Calibration
cal:                                  // Return here if Screen Re-cal is needed
  TFT_Set_Pen(CL_WHITE, 10);
  TFT_Fill_Screen(CL_RED);
  Calibrate();                // Call Touch Screen Calibration Routine
  Delay_ms(250);
//***************************************************************************
  if (EEPROM_READ(8) != 34)   // If dummy value not set (initial burn)
    {
    Eprom_Store(8);           //  Writes first 8 addresses
    EEPROM_Write(8, 34);      //  Writes address 9 for skip over later
    Delay_ms(50);
    }
skip:
  Eprom_Recall(8);            // Recalls 8 stored Screen Cal values
  Delay_ms(50);
  TFT_Fill_Screen(CL_RED);
  Display_MinMax();           // Display Screen Cal values
  Delay_ms(5000);
  DrawScreen(&Screen1);       // Refresh Screen
//****************************************************************************
  while (1 == 1) 
  {
    Check_TP();               // Scan Touch Screen for Press
    if (PORTE.F0 == 0)        // Press Button to Re-Calibrate Touch Screen
       {
       EEPROM_Write(8, 0);    // Allows Eprom Re-Write
       goto cal;
       }
    Display_X10_TFT();
  } // End While

} // End Main
//****************************************************************************