enum GlcdColor {_clClear, _clDraw, _clInvert};

typedef struct Screen TScreen;

typedef struct  Button {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  char          *Caption;
  const char    *FontName;
  unsigned int  Font_Color;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TButton;

typedef struct  Label {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          *Caption;
  const char    *FontName;
  unsigned int  Font_Color;
  char          Visible;
  char          Active;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TLabel;

struct Screen {
  unsigned int           Color;
  unsigned int           Width;
  unsigned int           Height;
  unsigned short         ObjectsCount;
  unsigned int           ButtonsCount;
  TButton                * const code *Buttons;
  unsigned int           LabelsCount;
  TLabel                 * const code *Labels;
};

extern   TScreen                Screen1;
extern   TLabel                 Label1;
extern   TLabel                 Label2;
extern   TButton               Button1;
extern   TButton               Button2;
extern   TButton               Button3;
extern   TButton               Button4;
extern   TButton               Button5;
extern   TButton               Button6;
extern   TButton               Button7;
extern   TButton               Button8;
extern   TButton               Button17;
extern   TButton               Button18;
extern   TButton               Button19;
extern   TLabel                 Label5;
extern   TLabel                 Label6;
extern   TButton                * const code Screen1_Buttons[11];
extern   TLabel                 * const code Screen1_Labels[4];


extern   TScreen                Screen2;
extern   TLabel                 Label3;
extern   TLabel                 Label4;
extern   TButton               Button9;
extern   TButton               Button10;
extern   TButton               Button11;
extern   TButton               Button12;
extern   TButton               Button13;
extern   TButton               Button14;
extern   TButton               Button15;
extern   TButton               Button16;
extern   TButton               Button24;
extern   TButton               Button25;
extern   TButton               Button22;
extern   TLabel                 Label7;
extern   TLabel                 Label8;
extern   TButton                * const code Screen2_Buttons[11];
extern   TLabel                 * const code Screen2_Labels[4];



/////////////////////////
// Events Code Declarations
void Button1Down();
void Button2Down();
void Button3Down();
void Button4Down();
void Button5Down();
void Button6Down();
void Button7Down();
void Button8Down();
void Button17Down();
void Button18Down();
void Button19Down();
void Button9Down();
void Button10Down();
void Button11Down();
void Button12Down();
void Button13Down();
void Button14Down();
void Button15Down();
void Button16Down();
void Button24Down();
void Button25Down();
void Button22Down();
/////////////////////////

/////////////////////////////////
// Caption variables Declarations
extern char Label1_Caption[];
extern char Label2_Caption[];
extern char Button1_Caption[];
extern char Button2_Caption[];
extern char Button3_Caption[];
extern char Button4_Caption[];
extern char Button5_Caption[];
extern char Button6_Caption[];
extern char Button7_Caption[];
extern char Button8_Caption[];
extern char Button17_Caption[];
extern char Button18_Caption[];
extern char Button19_Caption[];
extern char Label5_Caption[];
extern char Label6_Caption[];
extern char Label3_Caption[];
extern char Label4_Caption[];
extern char Button9_Caption[];
extern char Button10_Caption[];
extern char Button11_Caption[];
extern char Button12_Caption[];
extern char Button13_Caption[];
extern char Button14_Caption[];
extern char Button15_Caption[];
extern char Button16_Caption[];
extern char Button24_Caption[];
extern char Button25_Caption[];
extern char Button22_Caption[];
extern char Label7_Caption[];
extern char Label8_Caption[];
/////////////////////////////////

void DrawScreen(TScreen *aScreen);
void DrawButton(TButton *aButton);
void DrawLabel(TLabel *ALabel);
void Check_TP();
void Start_TP();